<?php

use Illuminate\Http\Request;

Route::group(['prefix' => 'v1'], function () {
    Route::middleware('auth:api')->get('/user', function (Request $request) {
        return $request->user();
    });
});

/**
 * group api v1 routes under
 * Api\v1 directory in controllers
 */
Route::group(['prefix' => 'v1', 'namespace' => 'Api\v1'], function () {
    Route::apiResource('/posts', 'PostController');
    
    Route::group(['prefix' => 'posts' ], function () {
        Route::apiResource('{post}/comments', 'CommentController');
    });
});

Route::group(['prefix' => 'v1'], function () {
    // ...
    Route::post('/login', 'Auth\ApiAuthController@login')->name('login.api');
//    Route::get('/wilayalist', 'Auth\ApiAuthController@wilayalist')->name('wilayalist.api');
    Route::post('/register','Auth\ApiAuthController@register')->name('register.api');
    Route::post('/logout', 'Auth\ApiAuthController@logout')->name('logout.api');
	Route::post('/regions', 'Auth\ApiAuthController@regionlistByWilaya')->name('regions.api');
    Route::get('/wilaya', 'Auth\ApiAuthController@wilayaList')->name('wilaya.api');
	Route::get('/countries', 'Auth\ApiAuthController@countriesList')->name('countries.api');
    Route::post('/cities', 'Auth\ApiAuthController@citilistByCountry')->name('cities.api');
    Route::post('/calculatePrice','Auth\ApiAuthController@calculatePrice')->name('calculatePrice.api');		
	
	Route::post('/calculatePriceUpdated','Auth\ApiAuthController@calculatePriceUpdated')->name('calculatePriceUpdated.api');
	
    Route::post('/getOrderLog', 'Auth\ApiAuthController@getOrderLog')->name('getOrderLog.api');
    Route::post('/getOrderStatus', 'Auth\ApiAuthController@getOrderStatus')->name('getOrderStatus.api');
    
	Route::post('/addordertasheel', 'Auth\ApiAuthController@addordertasheel')->name('addordertasheel.api');
	Route::post('/addorderdalileeswaq', 'Auth\ApiAuthController@addorderdalileeswaq')->name('addorderdalileeswaq.api');
	Route::post('/getstoreData', 'Auth\ApiAuthController@getstoreData')->name('getstoreData.api');
	
	
	Route::post('/cancel_order', 'Auth\ApiAuthController@cancel_order')->name('cancel_order.api');
	
	Route::post('/getstoreData', 'Auth\ApiAuthController@getstoreData')->name('getstoreData.api');
	
   Route::post('/getOrderData','Auth\ApiAuthController@getOrderData')->name('getOrderData.api');
	
   Route::post('/verify_customer', 'Auth\ApiAuthController@verifyDalileeCustomer')->name('verify_customer.api');


});

Route::prefix('v1')->group(function () {
    
    Route::middleware(['auth:api'])->group(function () {		Route::post('/viewStoreData','Auth\ApiAuthController@viewStoreData')->name('viewStoreData.api');
		
        // These will be prefixed with "manager" and assigned the "manager_auth" middleware
   	Route::post('/signupTrader', 'Auth\ApiAuthController@signupTrader')->name('signupTrader.api');
    //Route::get('/wilayalist', 'Auth\ApiAuthController@signupTrader')->name('wilayalist.api');
    Route::post('/regionlist', 'Auth\ApiAuthController@regionlistByWilaya')->name('regionlist.api');
    Route::get('/wilayalist', 'Auth\ApiAuthController@wilayaList')->name('wilayalist.api');

    Route::get('/wilayalistUpdated', 'Auth\ApiAuthController@wilayalistUpdated')->name('wilayalistUpdated.api');
    
    Route::post('/updatedRegionList', 'Auth\ApiAuthController@updatedRegionList')->name('updatedRegionList.api');
    

    Route::post('/addreference', 'Auth\ApiAuthController@addref')->name('addreference.api');
    Route::post('/refrenceData', 'Auth\ApiAuthController@refrenceDataByID')->name('refrenceData.api');
    Route::post('/addorder', 'Auth\ApiAuthController@addorder')->name('addorder.api');
	 Route::post('/addordernew', 'Auth\ApiAuthController@addordernew')->name('addordernew.api');																												
	Route::post('/verifyStore', 'Auth\ApiAuthController@verifyStore')->name('verifyStore.api');														
    //Route::get('/getordersByrefrence', 'Auth\ApiAuthController@getorderByrefrence')->name('getorderByrefrence.api');
	Route::post('/getordersByrefrence', 'Auth\ApiAuthController@getorderByrefrence')->name('getordersByrefrence.api');													
	//Route::get('/getOrderLog', 'Auth\ApiAuthController@getOrderLog')->name('getOrderLog.api');	
    });

    // These will just be prefixed with "manager"
});